#ifndef __BITMAP_HEIGHTFIELD_H_
#define __BITMAP_HEIGHTFIELD_H_

#include "ObjectBase.h"

class BitmapHeightfield : public ObjectBase
{
private:
	GLfloat color[4];
	GLuint  list;
        
    GLfloat m_hFieldWidth;
    GLfloat m_hFieldDepth;
    float   m_scale;

    unsigned char* height_map;
    int m_stepWidth;
    int m_stepDepth;

public:
	BitmapHeightfield( dWorldID world, dSpaceID space, const char* file_name, float width, float depth, float h_scale );

	void setColor(GLfloat r, GLfloat g, GLfloat b, GLfloat a=1.0f);

protected:
    virtual void render();
    virtual void renderShadow();

	void renderInLocalFrame() const;
	void renderInit();

    const unsigned char* createHeightMapFromBitmap( const char* file_name, int* x_size, int* y_size );
};


#endif
