#ifndef __OBJECT_BASE_H_
#define __OBJECT_BASE_H_

#ifdef WIN32
#include <windows.h>
#endif

#include <ode/ode.h>
#include <GL/gl.h>

class ObjectBase
{
protected:
	dBodyID m_body;
	dGeomID m_geom;
    bool    m_flagShadow;

public:
    ObjectBase();
	~ObjectBase();

	virtual void render();
	virtual void renderShadow();
	void setPosition(dReal x, dReal y, dReal z);
    const dReal* getPosition() const;

    const dBodyID& body() const;
    const dGeomID& geom() const;

protected:
	virtual void renderInLocalFrame() const = 0;
};

#endif