/* Generated by re2c 0.13.5 on Tue Dec  1 21:35:43 2009 */
#line 1 "XReader.re"
#ifndef __ODE_UTILS_XREADER_H_
#define __ODE_UTILS_XREADER_H_

#include <fstream>
#include <sstream>

#include "TriMeshReaderBase.h"

namespace ode_utils {


template <typename V_TYPE, typename IDX_TYPE>
class XReader : public TriMeshReaderBase<V_TYPE, IDX_TYPE>
{
    enum {
        TOKEN_eof = 0,
        TOKEN_TEMPLATE,
        TOKEN_MESH = 10,
        TOKEN_LCUR,
        TOKEN_RCUR,
        TOKEN_SEMI,
        TOKEN_COMMA,
        TOKEN_STRING,
        TOKEN_REAL,
        TOKEN_INT, 
        TOKEN_ANY = 100,
    };


    typedef V_TYPE vertex_type;
    typedef IDX_TYPE index_type;
private:
    std::ifstream ifs;
 
    char* m_buffer;
    char* m_text;
 
    char* m_cursor_p;
    char* m_token_p;
    char* m_limit_p;
    char* m_marker_p;
 
    bool  m_endfile;
    int   m_bufsize;
    int   m_lineno;

    int   m_curTokenNo;

    std::ostringstream m_msg;
 
public:
 
    XReader( const char* file_name, int init_size=1024 )
        : TriMeshReaderBase<V_TYPE,IDX_TYPE>(file_name)
        , m_buffer(0)
        , m_text(0)
        , m_cursor_p(0)
        , m_token_p(0)
        , m_limit_p(0)
        , m_marker_p(0)
        , m_endfile(false)
        , m_bufsize(init_size)
        , m_lineno(0)
    {
        m_buffer = new char[m_bufsize];
        m_text = new char[m_bufsize];
 
        ifs.open( file_name, std::ios::in );
        if (!ifs) {
            m_msg << "can't not open file\n" << std::endl;
            m_msg << "file:" << file_name << "\n";
            return;
        }
        m_cursor_p = m_limit_p = m_token_p = m_marker_p = m_buffer;

        this->m_complete = createMeshData(file_name);

        if (this->m_complete) {
            m_msg << "x file load - completed.\n";
            m_msg << "file:" << file_name << "\n";
        } else {
            m_msg << "x file load - no completed.\n";
            m_msg << "file:" << file_name << "\n";
            m_msg << "error line=" << lineno() << ",";
            m_msg << "token=" << text() << "\n";
        }
    }
 
    ~XReader() {
        ifs.close();
        if (m_buffer) delete [] m_buffer;
        if (m_text) delete [] m_text;
    }
 
protected:
    void fill(int n) {

        if (ifs.eof() && (m_limit_p-m_cursor_p<=0)) {
            m_endfile = true;
            return;
        }

        if (m_bufsize - (m_limit_p - m_cursor_p) >= n+1) {
            int cnt = m_cursor_p - m_buffer;
            if (cnt > 0) {
                memmove( m_buffer, m_cursor_p, (m_limit_p-m_cursor_p)*sizeof(char) );
                m_cursor_p -= cnt;
                m_limit_p  -= cnt;
                m_token_p  -= cnt;
                m_marker_p -= cnt;
            }
        }
        else {
            while (m_bufsize - (m_limit_p - m_cursor_p) < n+1) {
                m_bufsize *= 2;
            }
            char* newbuff = new char[m_bufsize];
            memcpy( newbuff, m_cursor_p, (m_limit_p-m_cursor_p)*sizeof(char) );
            delete [] m_buffer;
            m_limit_p = &newbuff[m_limit_p-m_cursor_p];
            m_marker_p = &newbuff[m_marker_p-m_cursor_p];
            m_token_p = &newbuff[m_token_p-m_cursor_p];
            m_cursor_p = newbuff;
            m_buffer = newbuff;
        }
 
        int read_size = m_bufsize - (m_limit_p-m_buffer);
        ifs.read( m_limit_p, read_size );
        m_limit_p += ifs.gcount();
 
        if (ifs.eof()) {
            m_limit_p[0] = '\n';
        }
    }
 
    const char* text() {
        int i = 0;
        while (i<length()) {
            m_text[i] = m_token_p[i]; i++;
        }
        m_text[i] = '\0';
        return m_text;
    }
 
    int length() {
        return (m_cursor_p-m_token_p);
    }
 
    int lineno() {
        return m_lineno+1;
    }

    int token() {
        return m_curTokenNo;
    }

    int scan(void)
    {
        m_curTokenNo =  scanMain();
        return m_curTokenNo;
    }
 
    int scanMain(void)
    {
        if (m_endfile) { return TOKEN_eof; }
start:
        m_token_p = m_cursor_p;

    
#line 173 "XReader.h"
		{
			char yych;

			if ((m_limit_p - m_cursor_p) < 9) fill(9);
			yych = *m_cursor_p;
			switch (yych) {
			case '\t':
			case '\v':
			case '\f':
			case '\r':
			case ' ':	goto yy2;
			case '\n':	goto yy8;
			case '#':	goto yy4;
			case '$':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy25;
			case '+':
			case '-':	goto yy13;
			case ',':	goto yy23;
			case '.':	goto yy16;
			case '/':	goto yy6;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy14;
			case ';':	goto yy21;
			case 'M':	goto yy12;
			case 't':	goto yy10;
			case '{':	goto yy17;
			case '}':	goto yy19;
			default:	goto yy26;
			}
yy2:
			++m_cursor_p;
			yych = *m_cursor_p;
			goto yy58;
yy3:
#line 183 "XReader.re"
			{ goto start; }
#line 268 "XReader.h"
yy4:
			++m_cursor_p;
#line 184 "XReader.re"
			{ goto comment;  }
#line 273 "XReader.h"
yy6:
			++m_cursor_p;
			switch ((yych = *m_cursor_p)) {
			case '/':	goto yy55;
			default:	goto yy7;
			}
yy7:
#line 198 "XReader.re"
			{ return TOKEN_ANY; }
#line 283 "XReader.h"
yy8:
			++m_cursor_p;
#line 186 "XReader.re"
			{ m_lineno++; goto start;  }
#line 288 "XReader.h"
yy10:
			++m_cursor_p;
			switch ((yych = *m_cursor_p)) {
			case 'e':	goto yy47;
			default:	goto yy28;
			}
yy11:
#line 196 "XReader.re"
			{ return TOKEN_STRING; }
#line 298 "XReader.h"
yy12:
			yych = *++m_cursor_p;
			switch (yych) {
			case 'e':	goto yy43;
			default:	goto yy28;
			}
yy13:
			yych = *(m_marker_p = ++m_cursor_p);
			switch (yych) {
			case '+':
			case '-':	goto yy38;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy36;
			default:	goto yy7;
			}
yy14:
			++m_cursor_p;
			switch ((yych = *m_cursor_p)) {
			case '.':	goto yy34;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy32;
			default:	goto yy15;
			}
yy15:
#line 191 "XReader.re"
			{ return TOKEN_INT; }
#line 341 "XReader.h"
yy16:
			yych = *++m_cursor_p;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy29;
			default:	goto yy7;
			}
yy17:
			++m_cursor_p;
#line 192 "XReader.re"
			{ return TOKEN_LCUR; }
#line 361 "XReader.h"
yy19:
			++m_cursor_p;
#line 193 "XReader.re"
			{ return TOKEN_RCUR; }
#line 366 "XReader.h"
yy21:
			++m_cursor_p;
#line 194 "XReader.re"
			{ return TOKEN_SEMI; }
#line 371 "XReader.h"
yy23:
			++m_cursor_p;
#line 195 "XReader.re"
			{ return TOKEN_COMMA; }
#line 376 "XReader.h"
yy25:
			yych = *++m_cursor_p;
			goto yy28;
yy26:
			yych = *++m_cursor_p;
			goto yy7;
yy27:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
yy28:
			switch (yych) {
			case '$':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy27;
			default:	goto yy11;
			}
yy29:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy29;
			default:	goto yy31;
			}
yy31:
#line 190 "XReader.re"
			{ return TOKEN_REAL; }
#line 475 "XReader.h"
yy32:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
			switch (yych) {
			case '.':	goto yy34;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy32;
			default:	goto yy15;
			}
yy34:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy34;
			default:	goto yy31;
			}
yy36:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
			switch (yych) {
			case '.':	goto yy41;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy36;
			default:	goto yy15;
			}
yy38:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
			switch (yych) {
			case '+':
			case '-':	goto yy38;
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy36;
			default:	goto yy40;
			}
yy40:
			m_cursor_p = m_marker_p;
			goto yy7;
yy41:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
			switch (yych) {
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':	goto yy41;
			default:	goto yy31;
			}
yy43:
			yych = *++m_cursor_p;
			switch (yych) {
			case 's':	goto yy44;
			default:	goto yy28;
			}
yy44:
			yych = *++m_cursor_p;
			switch (yych) {
			case 'h':	goto yy45;
			default:	goto yy28;
			}
yy45:
			++m_cursor_p;
			switch ((yych = *m_cursor_p)) {
			case '$':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy27;
			default:	goto yy46;
			}
yy46:
#line 189 "XReader.re"
			{ return TOKEN_MESH; }
#line 652 "XReader.h"
yy47:
			yych = *++m_cursor_p;
			switch (yych) {
			case 'm':	goto yy48;
			default:	goto yy28;
			}
yy48:
			yych = *++m_cursor_p;
			switch (yych) {
			case 'p':	goto yy49;
			default:	goto yy28;
			}
yy49:
			yych = *++m_cursor_p;
			switch (yych) {
			case 'l':	goto yy50;
			default:	goto yy28;
			}
yy50:
			yych = *++m_cursor_p;
			switch (yych) {
			case 'a':	goto yy51;
			default:	goto yy28;
			}
yy51:
			yych = *++m_cursor_p;
			switch (yych) {
			case 't':	goto yy52;
			default:	goto yy28;
			}
yy52:
			yych = *++m_cursor_p;
			switch (yych) {
			case 'e':	goto yy53;
			default:	goto yy28;
			}
yy53:
			++m_cursor_p;
			switch ((yych = *m_cursor_p)) {
			case '$':
			case '0':
			case '1':
			case '2':
			case '3':
			case '4':
			case '5':
			case '6':
			case '7':
			case '8':
			case '9':
			case 'A':
			case 'B':
			case 'C':
			case 'D':
			case 'E':
			case 'F':
			case 'G':
			case 'H':
			case 'I':
			case 'J':
			case 'K':
			case 'L':
			case 'M':
			case 'N':
			case 'O':
			case 'P':
			case 'Q':
			case 'R':
			case 'S':
			case 'T':
			case 'U':
			case 'V':
			case 'W':
			case 'X':
			case 'Y':
			case 'Z':
			case '_':
			case 'a':
			case 'b':
			case 'c':
			case 'd':
			case 'e':
			case 'f':
			case 'g':
			case 'h':
			case 'i':
			case 'j':
			case 'k':
			case 'l':
			case 'm':
			case 'n':
			case 'o':
			case 'p':
			case 'q':
			case 'r':
			case 's':
			case 't':
			case 'u':
			case 'v':
			case 'w':
			case 'x':
			case 'y':
			case 'z':	goto yy27;
			default:	goto yy54;
			}
yy54:
#line 188 "XReader.re"
			{ return TOKEN_TEMPLATE; }
#line 761 "XReader.h"
yy55:
			++m_cursor_p;
#line 185 "XReader.re"
			{ goto comment;  }
#line 766 "XReader.h"
yy57:
			++m_cursor_p;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
yy58:
			switch (yych) {
			case '\t':
			case '\v':
			case '\f':
			case '\r':
			case ' ':	goto yy57;
			default:	goto yy3;
			}
		}
#line 199 "XReader.re"

comment:
    
#line 785 "XReader.h"
		{
			char yych;
			if (m_limit_p <= m_cursor_p) fill(1);
			yych = *m_cursor_p;
			switch (yych) {
			case '\n':	goto yy61;
			default:	goto yy63;
			}
yy61:
			++m_cursor_p;
#line 202 "XReader.re"
			{ m_lineno++; goto start;  }
#line 798 "XReader.h"
yy63:
			++m_cursor_p;
#line 203 "XReader.re"
			{ goto comment;  }
#line 803 "XReader.h"
		}
#line 204 "XReader.re"

    }

protected:
    virtual bool createMeshData( const char *file_name )
    {
        struct st_face {
            int element;
            int indexVertices[4];
        };

        int v;
        st_face *face = NULL;

        do {
            v = scan();

            if (v == TOKEN_TEMPLATE) {

                // skip

                int count = 0;
                while (true) {
                    v = scan();
                    if (v == TOKEN_eof) goto error;
                    else if (v == TOKEN_LCUR)  break;
                }
                count = 1;
                while (count > 0) {
                    v = scan();
                    if (v == TOKEN_eof) { goto error; }
                    else if (v == TOKEN_LCUR) count++;
                    else if (v == TOKEN_RCUR) count--;
                }
            }
            else if (v == TOKEN_MESH) {

                v = scan();
                if (v == TOKEN_STRING) {
                    v = scan();
                    if (v != TOKEN_LCUR) { goto error; }
                }
                else if (v == TOKEN_LCUR) { }
                else                      { goto error; }

                // VertexCount

                v = scan();
                if (v != TOKEN_INT) { goto error; }
                this->m_vertexCount = atoi( text() );

                v = scan();
                if (v != TOKEN_SEMI) { goto error; }

                // Vertices

                this->m_vertices = new vertex_type[this->m_vertexCount*3];

                for (int i=0; i<this->m_vertexCount; i++) {
                    for (int j=0; j<3; j++) {
                        v = scan();
                        if (v!=TOKEN_REAL && v!=TOKEN_INT) { goto error; }
                        this->m_vertices[i*3+j] = (vertex_type)atof( text() );

                        v = scan();
                        if (v != TOKEN_SEMI) { goto error; }
                    }
                    if (i!=this->m_vertexCount-1) {
                        v = scan();
                        if (v != TOKEN_COMMA) { goto error; }
                    }
                }
                v = scan();
                if (v != TOKEN_SEMI) { goto error; }

                // IndexCount

                v = scan();
                if (v != TOKEN_INT) { goto error; }
                this->m_indexCount = atoi( text() );

                v = scan();
                if (v != TOKEN_SEMI) { goto error; }

                face = new st_face[this->m_indexCount];

                for (int i=0; i<this->m_indexCount; i++) {
                    v = scan();
                    if (v != TOKEN_INT) { goto error; }
                    face[i].element = atoi( text() );
                    if ((face[i].element != 3) && (face[i].element !=4)) { goto error; }

                    v = scan();
                    if (v != TOKEN_SEMI) { goto error; }

                    for (int j=0; j<face[i].element; j++) {
                        v = scan();
                        if (v != TOKEN_INT) { goto error; }
                        face[i].indexVertices[j] = (index_type)atoi( text() );

                        v = scan();
                        if (j == face[i].element-1) {
                            if (v != TOKEN_SEMI) { goto error; }
                        } else {
                            if (v != TOKEN_COMMA) { goto error; }
                        }
                    }

                    v = scan();
                    if (i == this->m_indexCount-1) {
                        if (v != TOKEN_SEMI) { goto error; }
                    } else {
                        if (v != TOKEN_COMMA) { goto error; }
                    }
                }

                int count = 1;
                while (count > 0) {
                    v = scan();
                    if (v == TOKEN_eof) { goto error; }
                    else if (v == TOKEN_LCUR) { count++; }
                    else if (v == TOKEN_RCUR) { count--; }
                }
            }
        } while (v != TOKEN_eof);


        // convert 3or4 PolygonMesh -> TriMesh
        {
            int newIndexCnt = 0;
            for (int i=0; i<this->m_indexCount; i++) {
                newIndexCnt += (face[i].element - 2)*3;
            }
            this->m_indices = new index_type[newIndexCnt];

            int cnt = 0;
            for (int i=0; i<this->m_indexCount; i++) {
                if (cnt >= newIndexCnt) goto error;
                if (face[i].element == 3) {
                    this->m_indices[cnt+0] = face[i].indexVertices[0];
                    this->m_indices[cnt+1] = face[i].indexVertices[1];
                    this->m_indices[cnt+2] = face[i].indexVertices[2];
                    cnt+=3;
                } else if (face[i].element == 4) {
                    this->m_indices[cnt+0] = face[i].indexVertices[0];
                    this->m_indices[cnt+1] = face[i].indexVertices[1];
                    this->m_indices[cnt+2] = face[i].indexVertices[2];
                    this->m_indices[cnt+3] = face[i].indexVertices[0];
                    this->m_indices[cnt+4] = face[i].indexVertices[2];
                    this->m_indices[cnt+5] = face[i].indexVertices[3];
                    cnt+=6;
                } else { goto error; }
            }

            this->m_indexCount = newIndexCnt;
        }

        if (face) delete [] face;
        return true;

error:
        if (face) delete [] face;
        return false;
    }

public:
    const char* message() 
    {
        return m_msg.str().c_str();
    }

};

}; // namespace ode_utils;

#endif
